Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/LinkGenerator.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/LinkGenerator.java	(revision 29005)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/LinkGenerator.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2015 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -16,8 +16,6 @@
 package org.ametys.plugins.linkdirectory.link;
 
 import java.io.IOException;
-import java.util.ArrayList;
-import java.util.List;
 
 import org.apache.avalon.framework.service.ServiceException;
 import org.apache.avalon.framework.service.ServiceManager;
@@ -25,17 +23,11 @@
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Request;
 import org.apache.cocoon.generation.ServiceableGenerator;
-import org.apache.cocoon.xml.AttributesImpl;
-import org.apache.cocoon.xml.XMLUtils;
-import org.apache.commons.lang.StringUtils;
 import org.xml.sax.SAXException;
 
-import org.ametys.plugins.explorer.resources.Resource;
+import org.ametys.plugins.linkdirectory.DirectoryHelper;
 import org.ametys.plugins.linkdirectory.repository.DefaultLink;
-import org.ametys.plugins.linkdirectory.repository.DefaultTheme;
 import org.ametys.plugins.repository.AmetysObjectResolver;
-import org.ametys.plugins.repository.UnknownAmetysObjectException;
-import org.ametys.plugins.repository.metadata.BinaryMetadata;
 
 /**
  * Generate a directory link as XML.
@@ -63,109 +55,8 @@
         contentHandler.startDocument();
         
         DefaultLink link = _resolver.resolveById(id);
-        saxLink(link, themeLabelOnly);
+        DirectoryHelper.saxLink(contentHandler, link, themeLabelOnly, false, false);
         
         contentHandler.endDocument();
     }
-    
-    /**
-     * Generate a directory link.
-     * @param link the link to generate.
-     * @param saxThemesLabelOnly true to sax themes label only
-     * @throws SAXException If an error occurs while generating the XML.
-     */
-    protected void saxLink (DefaultLink link, boolean saxThemesLabelOnly) throws SAXException
-    {
-        AttributesImpl attrs = new AttributesImpl();
-        attrs.addCDATAAttribute("id", link.getId());
-        
-        attrs.addCDATAAttribute("url", StringUtils.defaultString(link.getUrl()));
-        attrs.addCDATAAttribute("title", StringUtils.defaultString(link.getTitle()));
-        attrs.addCDATAAttribute("content", StringUtils.defaultString(link.getContent()));
-        
-        attrs.addCDATAAttribute("alternative", StringUtils.defaultString(link.getAlternative()));
-        attrs.addCDATAAttribute("pictureAlternative", StringUtils.defaultString(link.getPictureAlternative()));
-        
-        String pictureType = link.getPictureType();
-        attrs.addCDATAAttribute("pictureType", pictureType);
-        if (pictureType.equals("resource"))
-        {
-            String resourceId = link.getResourcePictureId();
-            Resource resource = _resolver.resolveById(resourceId);
-            attrs.addCDATAAttribute("pictureId", resourceId);
-            attrs.addCDATAAttribute("pictureName", resource.getName());
-            attrs.addCDATAAttribute("pictureSize", Long.toString(resource.getLength()));
-            attrs.addCDATAAttribute("imageType", "explorer");
-        }
-        else if (pictureType.equals("external"))
-        {
-            BinaryMetadata picMeta = link.getExternalPicture();
-            attrs.addCDATAAttribute("picturePath", DefaultLink.METADATA_PICTURE);
-            attrs.addCDATAAttribute("pictureName", picMeta.getFilename());
-            attrs.addCDATAAttribute("pictureSize", Long.toString(picMeta.getLength()));
-            attrs.addCDATAAttribute("imageType", "metadata");
-        }
-        
-        XMLUtils.startElement(contentHandler, "link", attrs);
-        
-        // Themes.
-        if (saxThemesLabelOnly)
-        {
-            _saxThemesLabel(link);
-        }
-        else
-        {
-            _saxThemes(link);
-        }
-        
-        XMLUtils.endElement(contentHandler, "link");
-    }
-    
-    private void _saxThemes (DefaultLink link) throws SAXException
-    {
-        XMLUtils.startElement(contentHandler, "themes");
-        
-        for (String themeId : link.getThemes())
-        {
-            try
-            {
-                DefaultTheme theme = _resolver.resolveById(themeId);
-                
-                AttributesImpl attrs = new AttributesImpl();
-                attrs.addCDATAAttribute("id", themeId);
-                attrs.addCDATAAttribute("label", theme.getLabel());
-                
-                XMLUtils.createElement(contentHandler, "theme", attrs);
-            }
-            catch (UnknownAmetysObjectException e)
-            {
-                // Theme does not exist anymore
-            }
-        }
-            
-        
-        XMLUtils.endElement(contentHandler, "themes");
-    }
-    
-    
-    private void _saxThemesLabel (DefaultLink link) throws SAXException
-    {
-        List<String> themesLabel = new ArrayList<String>();
-        
-        for (String themeId : link.getThemes())
-        {
-            try
-            {
-                DefaultTheme theme = _resolver.resolveById(themeId);
-                themesLabel.add(theme.getLabel());
-            }
-            catch (UnknownAmetysObjectException e)
-            {
-                // Theme does not exist anymore
-            }
-        }
-        
-        XMLUtils.createElement(contentHandler, "themes", StringUtils.join(themesLabel, ", "));
-    }
-
 }
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/LinkListGenerator.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/LinkListGenerator.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/LinkListGenerator.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2015 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -16,49 +16,57 @@
 package org.ametys.plugins.linkdirectory.link;
 
 import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
 
 import org.apache.avalon.framework.service.ServiceException;
 import org.apache.avalon.framework.service.ServiceManager;
 import org.apache.cocoon.ProcessingException;
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.generation.ServiceableGenerator;
 import org.apache.cocoon.xml.AttributesImpl;
 import org.apache.cocoon.xml.XMLUtils;
+import org.apache.commons.lang.ArrayUtils;
 import org.apache.commons.lang.StringUtils;
 import org.xml.sax.SAXException;
 
 import org.ametys.plugins.linkdirectory.DirectoryHelper;
 import org.ametys.plugins.linkdirectory.repository.DefaultLink;
-import org.ametys.plugins.repository.AmetysObjectIterable;
-import org.ametys.plugins.repository.TraversableAmetysObject;
-import org.ametys.plugins.repository.query.expression.Expression;
-import org.ametys.plugins.repository.query.expression.OrExpression;
+import org.ametys.plugins.linkdirectory.theme.ThemeExpression;
+import org.ametys.web.WebConstants;
+import org.ametys.web.renderingcontext.RenderingContext;
+import org.ametys.web.renderingcontext.RenderingContextHandler;
 import org.ametys.web.repository.page.Page;
-import org.ametys.web.repository.site.Site;
-import org.ametys.web.repository.site.SiteManager;
+import org.ametys.web.repository.page.ZoneItem;
 
 /**
- * Generate the list of directory links as XML.
+ * Generate the links' list of a link directory as XML.
  */
-public class LinkListGenerator extends LinkGenerator
+public class LinkListGenerator extends ServiceableGenerator 
 {
-    private SiteManager _siteManager;
+    /** The rendering context handler */
+    private RenderingContextHandler _renderingContextHandler;
     
     @Override
     public void service(ServiceManager serviceManager) throws ServiceException
     {
         super.service(serviceManager);
-        _siteManager = (SiteManager) serviceManager.lookup(SiteManager.ROLE);
+        _renderingContextHandler = (RenderingContextHandler) serviceManager.lookup(RenderingContextHandler.ROLE);
     }
     
     @Override
     public void generate() throws IOException, SAXException, ProcessingException
     {
         Request request = ObjectModelHelper.getRequest(objectModel);
+        
+        Page page = (Page) request.getAttribute(Page.class.getName());
+
         String siteName = parameters.getParameter("siteName", (String) request.getAttribute("site"));
         String language = parameters.getParameter("language", (String) request.getAttribute("renderingLanguage"));
         String themes = parameters.getParameter("themes", request.getParameter("themes"));
-
+        
         boolean boMode = "true".equals(request.getParameter("bo-mode"));
         
         if (StringUtils.isEmpty(siteName))
@@ -69,11 +77,7 @@
         {
             language = request.getParameter("language");
         }
-        
-        Page page = (Page) request.getAttribute(Page.class.getName());
-        
-        Site site = _siteManager.getSite(siteName);
-        
+
         contentHandler.startDocument();
         
         AttributesImpl attrs = new AttributesImpl();
@@ -83,58 +87,74 @@
         {
             attrs.addCDATAAttribute("page", page.getId());
         }
-        XMLUtils.startElement(contentHandler, "links", attrs);
         
-        AmetysObjectIterable<DefaultLink> links = getLinks(site, language, themes);
-        
-        try
+        String login = null;
+        if (_renderingContextHandler.getRenderingContext().equals(RenderingContext.FRONT))
         {
-            for (DefaultLink link : links)
-            {
-                saxLink(link, boMode);
-            }
+            login = (String) request.getAttribute(WebConstants.FO_LOGIN);
         }
-        finally
+       
+        // Get the themes as a list
+        String[] themesArray = StringUtils.split(themes, ",");
+        List<String> themesIdsList = ArrayUtils.isEmpty(themesArray) ? new ArrayList<String> () : Arrays.asList(themesArray);
+        
+        List<DefaultLink> links = DirectoryHelper.getLinks(themesIdsList, login, siteName, language);
+        
+        String storageContext = null;
+        
+        // Get the zone item if we sax for a service
+        if (!boMode)
         {
-            if (links != null)
+            ZoneItem zoneItem = (ZoneItem) request.getAttribute(ZoneItem.class.getName());
+            attrs.addCDATAAttribute("zoneItemId", zoneItem.getId());
+            
+            if (login != null)
             {
-                links.close();
+                storageContext = DirectoryHelper.getSiteName(request) + "/" + DirectoryHelper.getLanguage(request) + "/" + zoneItem.getId();
             }
         }
         
+        // SAX the links
+        XMLUtils.startElement(contentHandler, "links", attrs);
+        try
+        {
+            // Sax the amount of deleted themes 
+            _saxDeletedThemes(siteName, language, themesIdsList);
+            
+            DirectoryHelper.saxLinks(contentHandler, links, DirectoryHelper.getContextVars(request), storageContext, login, boMode, true);
+        }
+        catch (Exception e)
+        {
+            getLogger().error("An exception occurred while saxing the links", e);
+        }
         XMLUtils.endElement(contentHandler, "links");
+        
         contentHandler.endDocument();
     }
 
     /**
-     * Get the links.
-     * @param site the site.
-     * @param language the language.
-     * @param themes the themes or null.
-     * @return the links.
+     * Sax the amount of deleted themes
+     * @param siteName the site's name
+     * @param language the language
+     * @param themesIdsList the list of theme ids
+     * @throws SAXException if an exception occurs while saxing
      */
-    protected AmetysObjectIterable<DefaultLink> getLinks(Site site, String language, String themes)
+    protected void _saxDeletedThemes(String siteName, String language, List<String> themesIdsList) throws SAXException
     {
-        AmetysObjectIterable<DefaultLink> links;
-        if (StringUtils.isEmpty(themes))
+        int amount = 0;
+        for (String themeId : themesIdsList)
         {
-            TraversableAmetysObject linksNode = DirectoryHelper.getLinksNode(site, language);
-            links = linksNode.getChildren();
-        }
-        else
-        {
-            String[] themeArr = StringUtils.split(themes, ',');
-            Expression[] expressions = new Expression[themeArr.length];
-            
-            for (int i = 0; i < themeArr.length; i++)
+            if (!DirectoryHelper.themeExists(siteName, language, new ThemeExpression(themeId)))
             {
-                expressions[i] = new ThemeExpression(themeArr[i]);
+                // The theme was deleted but it is still referenced by the service
+                getLogger().warn("The id '" + themeId + "' does not reference an existing theme.");
+                amount += 1;
             }
-            
-            String query = DirectoryHelper.getLinkQuery(site.getName(), language, new OrExpression(expressions));
-            
-            links = _resolver.query(query);
+        }
+        
+        if (amount > 0)
+        {
+            XMLUtils.createElement(contentHandler, "deleted-themes", Integer.toString(amount));
         }
-        return links;
     }
 }
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/MoveLinkAction.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/MoveLinkAction.java	(revision 0)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/MoveLinkAction.java	(revision 0)
@@ -0,0 +1,169 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.linkdirectory.link;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import javax.jcr.RepositoryException;
+
+import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.acting.ServiceableAction;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Redirector;
+import org.apache.cocoon.environment.SourceResolver;
+
+import org.ametys.plugins.linkdirectory.repository.DefaultLink;
+import org.ametys.plugins.repository.AmetysObject;
+import org.ametys.plugins.repository.AmetysObjectIterable;
+import org.ametys.plugins.repository.AmetysObjectResolver;
+import org.ametys.plugins.repository.ModifiableAmetysObject;
+import org.ametys.plugins.repository.TraversableAmetysObject;
+
+/**
+ * Action that moves a link in JCR
+ */
+public class MoveLinkAction extends ServiceableAction
+{
+    /** The Ametys object resolver */
+    protected AmetysObjectResolver _resolver;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        super.service(serviceManager);
+        _resolver = (AmetysObjectResolver) serviceManager.lookup(AmetysObjectResolver.ROLE);
+    }
+    
+    @Override
+    public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
+    {
+        Map<String, String> result = new HashMap<String, String>();
+        Map<String, Object> jsParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
+        
+        String id = parameters.getParameter("id", (String) jsParameters.get("id"));
+        String role = parameters.getParameter("role", (String) jsParameters.get("role"));
+        
+        DefaultLink link = _resolver.resolveById(id);
+        
+        if ("move-first".equals(role))
+        {
+            _moveFirst(link);
+        }
+        else if ("move-up".equals(role))
+        {
+            _moveUp(link);
+        }
+        else if ("move-down".equals(role))
+        {
+            _moveDown(link);
+        }
+        else if ("move-last".equals(role))
+        {
+            _moveLast(link);
+        }
+        
+        return result;
+    }
+    
+    /**
+     * Move first.
+     * @param link 
+     * @throws RepositoryException
+     */
+    private void _moveFirst(DefaultLink link) throws RepositoryException
+    {
+        AmetysObjectIterable<AmetysObject>  children = null;
+        try
+        {
+            children = ((TraversableAmetysObject) link.getParent()).getChildren();
+            // Resolve the link in the same session or the linkRoot.saveChanges() call below won't see the order changes.
+            link.orderBefore(((TraversableAmetysObject) link.getParent()).getChildren().next());
+            ((ModifiableAmetysObject) link.getParent()).saveChanges();
+        }
+        finally
+        {
+            if (children != null)
+            {
+                children.close();
+            }
+        }
+    }
+
+    /**
+     * Move down.
+     * @param link 
+     * @throws RepositoryException
+     */
+    private void _moveDown(DefaultLink link) throws RepositoryException
+    {
+        TraversableAmetysObject parentNode = link.getParent();
+        AmetysObjectIterable<AmetysObject> siblings = parentNode.getChildren();
+        
+        boolean iterate = true;
+        while (siblings.hasNext() && iterate)
+        {
+            DefaultLink sibling = (DefaultLink) siblings.next();
+            iterate = !sibling.getName().equals(link.getName());
+        }
+        
+        // Move the link after his next sibling: move the next sibling before the link to move.
+        DefaultLink nextLink = (DefaultLink) siblings.next();
+        nextLink.orderBefore(link);
+
+        link.saveChanges();
+    }
+    
+    /**
+     * Move up.
+     * @param link
+     * @throws RepositoryException
+     */
+    private void _moveUp(DefaultLink link) throws RepositoryException
+    {
+        TraversableAmetysObject parentNode = link.getParent();
+        AmetysObjectIterable<AmetysObject> siblings = parentNode.getChildren();
+        DefaultLink previousLink = null;
+
+        while (siblings.hasNext())
+        {
+            DefaultLink sibling = (DefaultLink) siblings.next();
+            if (sibling.getName().equals(link.getName()))
+            {
+                break;
+            }
+            
+            previousLink = sibling;
+        }
+            
+        // Move the link after his next sibling: move the next sibling before the link to move.
+        link.orderBefore(previousLink);
+        link.saveChanges();
+    }
+    
+    /**
+     * Move last.
+     * @param link 
+     * @throws RepositoryException
+     */
+    private void _moveLast(DefaultLink link) throws RepositoryException
+    {
+        link.moveTo(link.getParent(), false);
+        ((ModifiableAmetysObject) link.getParent()).saveChanges();
+    }
+}
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/UpdateLinkAction.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/UpdateLinkAction.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/link/UpdateLinkAction.java	(working copy)
@@ -55,6 +55,13 @@
         String pictureType = (String) jsParameters.get("picture#type");
         String pictureAlternative = StringUtils.defaultString((String) jsParameters.get("picture-alternative"));
         String themesStr = (String) jsParameters.get("themes");
+        boolean grantAnyUser = (Boolean) jsParameters.get("grant-any-user");
+        
+        String foUsers = (String) jsParameters.get("fousers");
+        String foGroups = (String) jsParameters.get("fogroups");
+        
+        String[] grantedUsers = StringUtils.split(foUsers, ',');
+        String[] grantedGroups = StringUtils.split(foGroups, ',');
         
         try
         {
@@ -97,6 +104,10 @@
                 link.setExternalPicture(finalMimeType, filename, upload.getInputStream());
             }
             
+            link.setGrantAnyUser(grantAnyUser); 
+            link.setGrantedUsers(grantedUsers);
+            link.setGrantedGroups(grantedGroups);
+            
             link.saveChanges();
             
             result.put("id", link.getId());
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/repository/DefaultLink.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/repository/DefaultLink.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/repository/DefaultLink.java	(working copy)
@@ -24,11 +24,14 @@
 import javax.jcr.Value;
 
 import org.apache.commons.lang.ArrayUtils;
+import org.apache.commons.lang.StringUtils;
 
 import org.ametys.plugins.linkdirectory.Link;
 import org.ametys.plugins.repository.AmetysObject;
 import org.ametys.plugins.repository.AmetysRepositoryException;
+import org.ametys.plugins.repository.MovableAmetysObject;
 import org.ametys.plugins.repository.RepositoryConstants;
+import org.ametys.plugins.repository.RepositoryIntegrityViolationException;
 import org.ametys.plugins.repository.jcr.SimpleAmetysObject;
 import org.ametys.plugins.repository.metadata.BinaryMetadata;
 import org.ametys.plugins.repository.metadata.ModifiableBinaryMetadata;
@@ -39,7 +42,7 @@
 /**
  * Repository implementation of a directory link.
  */
-public class DefaultLink extends SimpleAmetysObject<DefaultLinkFactory> implements Link, SiteAwareAmetysObject
+public class DefaultLink extends SimpleAmetysObject<DefaultLinkFactory> implements Link, SiteAwareAmetysObject, MovableAmetysObject
 {
     
     /** Constant for URL metadata. */
@@ -60,6 +63,12 @@
     public static final String METADATA_PICTURE_ALTERNATIVE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-alternative";
     /** Constant for themes metadata. */
     public static final String METADATA_THEMES = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":themes";
+    /** Constant for grant-any-user metadata. */
+    public static final String METADATA_GRANT_ANY_USER = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":grant-any-user";
+    /** Constant for granted-users metadata. */
+    public static final String METADATA_GRANTED_USERS = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":granted-users";
+    /** Constant for granted-groups metadata. */
+    public static final String METADATA_GRANTED_GROUPS = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":granted-groups";
     
     /**
      * Create a {@link DefaultLink}.
@@ -330,57 +339,78 @@
     @Override
     public String[] getThemes() throws AmetysRepositoryException
     {
+        return _getListFromMetadataName(METADATA_THEMES);
+    }
+
+    @Override
+    public void setThemes(String[] themes) throws AmetysRepositoryException
+    {
+        _setListWithMetadataName(themes, METADATA_THEMES);
+    }
+
+    @Override
+    public void removeTheme (String themeId) throws AmetysRepositoryException
+    {
         try
         {
-            if (getNode().hasProperty(METADATA_THEMES))
-            {
-                Value[] values = getNode().getProperty(METADATA_THEMES).getValues();
-                
-                String[] themes = new String[values.length];
-                
-                for (int i = 0; i < values.length; i++)
-                {
-                    themes[i] = values[i].getString();
-                }
-                
-                return themes;
-            }
-            else
-            {
-                return new String[0];
-            }
+            String[] themes = getThemes();
+            String[] updatedThemes = (String[]) ArrayUtils.removeElement(themes, themeId);
+            getNode().setProperty(METADATA_THEMES, updatedThemes);
         }
         catch (RepositoryException e)
         {
-            throw new AmetysRepositoryException("Error getting the themes property.", e);
+            throw new AmetysRepositoryException("Error removing theme of id " + themeId, e);
         }
     }
     
     @Override
-    public void setThemes(String[] themes) throws AmetysRepositoryException
+    public String[] getGrantedUsers() throws AmetysRepositoryException
+    {
+        return _getListFromMetadataName(METADATA_GRANTED_USERS);
+    }
+    
+    @Override
+    public void setGrantedUsers(String[] grantedUsers) throws AmetysRepositoryException
+    {
+        _setListWithMetadataName(grantedUsers, METADATA_GRANTED_USERS);
+    }
+    
+    @Override
+    public String[] getGrantedGroups() throws AmetysRepositoryException
     {
+        return _getListFromMetadataName(METADATA_GRANTED_GROUPS);
+    }
+    
+    @Override
+    public void setGrantedGroups(String[] grantedGroups) throws AmetysRepositoryException
+    {
+        _setListWithMetadataName(grantedGroups, METADATA_GRANTED_GROUPS);
+    }
+    
+    @Override
+    public boolean isAllowedAnyUser() throws AmetysRepositoryException
+    {
+        Node node = getNode();
         try
         {
-            getNode().setProperty(METADATA_THEMES, themes);
+            return node.hasProperty(METADATA_GRANT_ANY_USER) ? getNode().getProperty(METADATA_GRANT_ANY_USER).getBoolean() : false;
         }
         catch (RepositoryException e)
         {
-            throw new AmetysRepositoryException("Error setting the themes property.", e);
+            throw new AmetysRepositoryException("An error occurred while trying to get the 'grant-any-user' property.", e);
         }
     }
     
     @Override
-    public void removeTheme (String themeId) throws AmetysRepositoryException
+    public void setGrantAnyUser(boolean grantAnyUser) throws AmetysRepositoryException
     {
         try
         {
-            String[] themes = getThemes();
-            String[] updatedThemes = (String[]) ArrayUtils.removeElement(themes, themeId);
-            getNode().setProperty(METADATA_THEMES, updatedThemes);
+            getNode().setProperty(METADATA_GRANT_ANY_USER, grantAnyUser);
         }
         catch (RepositoryException e)
         {
-            throw new AmetysRepositoryException("Error removing theme of id " + themeId, e);
+            throw new AmetysRepositoryException("An error occurred while trying to set the 'grant-any-user' property.", e);
         }
     }
     
@@ -420,4 +450,119 @@
         }
     }
     
+    @Override
+    public void orderBefore(AmetysObject siblingObject) throws AmetysRepositoryException
+    {
+        if (siblingObject instanceof DefaultLink)
+        {
+            DefaultLink sibling = (DefaultLink) siblingObject;
+            sibling.getPath();
+            Node node = getNode();
+            String siblingPath = "";
+            try
+            {
+                siblingPath = sibling.getNode().getPath();
+                if (siblingPath.contains("/"))
+                {
+                    siblingPath = StringUtils.substringAfterLast(siblingPath, "/");
+                }
+                String path = node.getPath();
+                if (path.contains("/"))
+                {
+                    path = StringUtils.substringAfterLast(path, "/");
+                }
+                node.getParent().orderBefore(path, siblingPath);
+            }
+            catch (RepositoryException e)
+            {
+                throw new AmetysRepositoryException(String.format("Unable to order link '%s' before link '%s'", this, siblingPath), e);
+            }
+        }
+        else
+        {
+            throw new AmetysRepositoryException("A link can only be moved before another link.");
+        }
+    }
+    
+    @Override
+    public void moveTo(AmetysObject newParent, boolean renameIfExist) throws AmetysRepositoryException, RepositoryIntegrityViolationException
+    {
+        if (getParent().equals(newParent))
+        {
+            try
+            {
+                // Just order current node to the end.
+                Node node = getNode();
+                String path = node.getPath();
+                if (path.contains("/"))
+                {
+                    path = StringUtils.substringAfterLast(path, "/");
+                }
+                node.getParent().orderBefore(path, null);
+            }
+            catch (RepositoryException e)
+            {
+                throw new AmetysRepositoryException(String.format("Unable to move link '%s' outside the root link node.", this), e);
+            }
+        }
+        else
+        {
+            throw new AmetysRepositoryException("A link can only be moved before another link.");
+        }
+    }
+
+    @Override
+    public boolean canMoveTo(AmetysObject newParent) throws AmetysRepositoryException
+    {
+        return getParent().equals(newParent);
+    }
+    
+    /**
+     * Retrieves the list of values corresponding to the metadata name passed as parameter
+     * @param metadataName the name of the metadata to retrieve
+     * @return the list corresponding to the metadata name
+     */
+    private String[] _getListFromMetadataName(String metadataName)
+    {
+        try
+        {
+            if (getNode().hasProperty(metadataName))
+            {
+                Value[] values = getNode().getProperty(metadataName).getValues();
+                
+                String[] list = new String[values.length];
+                
+                for (int i = 0; i < values.length; i++)
+                {
+                    list[i] = values[i].getString();
+                }
+                
+                return list;
+            }
+            else
+            {
+                return new String[0];
+            }
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("An error occurred while trying to get the property '" + metadataName + "'.", e);
+        }
+    }
+    
+    /**
+     * Sets the list of values to the node corresponding to the metadata name passed as a parameter
+     * @param list the list of value to be set
+     */
+    private void _setListWithMetadataName(String[] list, String metadataName)
+    {
+        try
+        {
+            getNode().setProperty(metadataName, list);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("An error occurred while trying to set the property '" + metadataName + "'.", e);
+        }
+    }
 }
